//
//  CMRAppTypes.h
//  BathyScaphe
//
//  Updated by Tsutomu Sawada on 09/07/19.
//  Copyright 2005-2009 BathyScaphe Project. All rights reserved.
//  encoding="UTF-8"
//

#import <Foundation/Foundation.h>


enum {
    ThreadStandardStatus        = 0,
    ThreadNoCacheStatus         = 1,
    ThreadLogCachedStatus       = 1 << 1,
    ThreadUpdatedStatus         = (1 << 2) | ThreadLogCachedStatus,
    ThreadNewCreatedStatus      = (1 << 3) | ThreadNoCacheStatus,
    ThreadHeadModifiedStatus    = (1 << 4) | ThreadLogCachedStatus // Available in BathyScaphe 1.2 and later.
};
typedef unsigned int ThreadStatus;


enum {
    ThreadViewerMoveToIndexLinkType,
    ThreadViewerOpenBrowserLinkType,
    ThreadViewerResPopUpLinkType,
};
typedef unsigned int ThreadViewerLinkType;


enum {
    CMRAutoscrollNone             = 0,
    CMRAutoscrollWhenTLUpdate     = 1,
    CMRAutoscrollWhenTLSort       = 1 << 1,
    CMRAutoscrollWhenThreadUpdate = 1 << 2,
    CMRAutoscrollWhenTLVMChange   = 1 << 3, // Available in Tenori Tiger.
    CMRAutoscrollWhenThreadDelete = 1 << 4, // Available in BathyScaphe 1.6.3 "Hinagiku" and later.
    CMRAutoscrollAny              = 0xffffffffU,
    CMRAutoscrollStandard         = CMRAutoscrollAny ^ CMRAutoscrollWhenThreadDelete, // Available in BathyScaphe 1.6.3 "Hinagiku" and later.
};
typedef unsigned int CMRAutoscrollCondition; // Available in BathyScaphe 1.6.3 "Hinagiku" and later.


enum {
    kSpamFilterChangeTextColorBehavior = 1,
    kSpamFilterLocalAbonedBehavior,
    kSpamFilterInvisibleAbonedBehavior
};


enum {
    CMRSearchOptionNone                  = 0,
    CMRSearchOptionCaseInsensitive       = 1,
    CMRSearchOptionBackwards             = 1 << 1,
    CMRSearchOptionZenHankakuInsensitive = 1 << 2,
    CMRSearchOptionIgnoreSpecified       = 1 << 3,
    CMRSearchOptionLinkOnly              = 1 << 4,
    CMRSearchOptionUseRegularExpression  = 1 << 5 // Available in Starlight Breaker.
};
typedef unsigned int CMRSearchMask;


enum {
    BSOpenInBrowserAll          = 2,
    BSOpenInBrowserLatestFifty  = 0,
    BSOpenInBrowserFirstHundred = 1
};
typedef unsigned int BSOpenInBrowserType;


enum {
    BSBeLoginTriviallyNeeded = 0, // Be ログイン必須
    BSBeLoginTriviallyOFF    = 1, // Be ログインは無意味（2chではない掲示板など）
    BSBeLoginDecidedByUser   = 2, // Be ログインするかどうかはユーザの設定を参照する
    BSBeLoginNoAccountOFF    = 3  // 環境設定で Be アカウントが設定されていない
};
typedef unsigned int BSBeLoginPolicyType;


enum {
    BSThreadsListShowsLiveThreads = 0,
    BSThreadsListShowsStoredLogFiles = 1,
}; // Available in Twincam Angel and later.
typedef unsigned int BSThreadsListViewModeType;
